<?php
namespace bwdwcgx_WooCatGallery_namespace;

use bwdwcgx_WooCatGallery_namespace\PageSettings\Page_Settings;
define( "bwdwcgx_ASFSK_ASSETS_PUBLIC_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/public" );
define( "bwdwcgx_ASFSK_ASSETS_ADMIN_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/admin" );
class Classbwdwcgx_woo_cat_gallery {

	private static $_instance = null;

	public static function instance() {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	public function bwdwcgx_admin_editor_scripts() {
		add_filter( 'script_loader_tag', [ $this, 'bwdwcgx_admin_editor_scripts_as_a_module' ], 10, 2 );
	}

	public function bwdwcgx_admin_editor_scripts_as_a_module( $tag, $handle ) {
		if ( 'bwdwcgx_WooCatGallery_editor' === $handle ) {
			$tag = str_replace( '<script', '<script type="module"', $tag );
		}

		return $tag;
	}

	private function include_widgets_files() {
		require_once( __DIR__ . '/widgets/bwdwcgx-woo-cat-gallery-widgets.php' );
	}

	public function bwdwcgx_register_widgets() {
		// Its is now safe to include Widgets files
		$this->include_widgets_files();

		// Register WidgetsF
		\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdwcgx_WooCatGallery_widgets());
	}

	private function add_page_settings_controls() {
		require_once( __DIR__ . '/page-settings/bwdwcgx-woo-cat-gallery-manager.php' );
		new Page_Settings();
	}

	// Register Category
	function bwdwcgx_WooCatGallery_add_elementor_widget_categories( $elements_manager ) {

		$elements_manager->add_category(
			'bwdwcgx-WooCatGallery-category',
			[
				'title' => esc_html__( 'WooCat Gallery Pro', 'bwdwcgx-woocat-gallery' ),
				'icon' => 'eicon-person',
			]
		);
	}

	//css-js-link-here
	public function bwdwcgx_all_assets_for_the_public(){

		wp_enqueue_script( 'bwdwcgx-WooCatGallery-main', plugin_dir_url( __FILE__ ) . 'assets/public/js/main.js', array('jquery'), '1.3', true );

		$all_css_file = array(
			'bwdwcgx-WooCatGallery-plugin-main' => array('bwdwcgx-WooCatGallery_css_path_define'=>bwdwcgx_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/css/main.css'),
        );
        foreach($all_css_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdwcgx-WooCatGallery_css_path_define'], null, '1.3', 'all');
        }

	}

	//admin-icon
	public function bwdwcgx_all_assets_for_elementor_editor_admin(){
		$all_css_js_file = array(
            'bwdwcgx-WooCatGallery-admin-main' => array('bwdwcgx_path_admin_define'=>bwdwcgx_ASFSK_ASSETS_ADMIN_DIR_FILE . '/css/icon.css'),
        );
        foreach($all_css_js_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdwcgx_path_admin_define'], null, '1.3', 'all');
        }
	}

	public function __construct() {

		// For public assets
		add_action('wp_enqueue_scripts', [$this, 'bwdwcgx_all_assets_for_the_public']);

		// For Elementor Editor
		add_action('elementor/editor/before_enqueue_scripts', [$this, 'bwdwcgx_all_assets_for_elementor_editor_admin']);

		// Register Category
		add_action( 'elementor/elements/categories_registered', [ $this, 'bwdwcgx_WooCatGallery_add_elementor_widget_categories' ] );

		// Register widgets
		add_action( 'elementor/widgets/widgets_registered', [ $this, 'bwdwcgx_register_widgets' ] );

		// Register editor scripts
		add_action( 'elementor/editor/after_enqueue_scripts', [ $this, 'bwdwcgx_admin_editor_scripts' ] );

		add_action('add_eael_progressbar_block', [$this, 'add_box_progress_bar_block'], 10, 3);

		$this->add_page_settings_controls();
	}
}

// Instantiate Plugin Class
Classbwdwcgx_woo_cat_gallery::instance();